# although screws up in twinview. hmmm..
#' get screen resolution of a monitor (may not work)
#' @param quietly whether to fail quietly if the screen resolution can not
#' be found, or throw and error.
#' @return c(horizontal,vertical) screen resolution. NULL if not found.
#' @export
getScreenResolution <- function(quietly=FALSE)
{
    # unix...
    if ( !is.null((PROG <- getProgram('xdpyinfo'))) ) {
        tmp <- system(sprintf("%s | grep dimensions",PROG[1]), intern=T)
        tmp <- strsplit(tmp,"[ ]")[[1]]
        tmp <- tmp[grep('\\b[0-9]{3,5} ?[Xx] ?[0-9]{3,5}\\b',tmp,perl=T)][1]
        szs <- as.integer(strsplit(tmp,'[Xx]')[[1]])  # size of screen
    } else if ( !is.null((PROG <- getProgram(c('wmic','wmic.exe')))) ) {
    # windows...
        scr_width <- system(sprintf("%s desktopmonitor get screenwidth",
                                     PROG[1]), intern=TRUE)
        # [1] "ScreenWidth  \r" "1440         \r" "\r"
        scr_height <- system(sprintf("%s desktopmonitor get screenheight",
                                     PROG[1]), intern=TRUE)
        szs <- as.numeric(c(
                       scr_width[-c(1, length(scr_width))], 
                         scr_height[-c(1, length(scr_height))]
        ))
    } else {
        if ( quietly )
            szs <- NULL
        else
            stop("getScreenResolution: could not get screen size")
    }

    return(szs)
}
